/*================================================================================================================*/
// *********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
// THE MISTASSINI WAR:
// CREATED BY DANY:
// APRIL 2007:
/*===============================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// ************************************** FOUR NATIVES APPEAR ON THIS MAP: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
	
	    int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
        int subCiv4=-1;
        int subCiv5=-1;
		
		if (rmAllocateSubCivs(6) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");

		subCiv4=rmGetCivID("Cherokee");
        if (subCiv4 >= 0)
        rmSetSubCiv(4, "Cherokee");

		subCiv5=rmGetCivID("Cherokee");
        if (subCiv5 >= 0)
        rmSetSubCiv(5, "Cherokee");
   }		 
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int playerTiles=17500;
	    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// ***************************************** PICKS THE MAP PARAMETERS: ***************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    // SET WIND MAGNITUDE:
		rmSetWindMagnitude(2);

	    // PICKS A DEFAULT WATER HEIGHT:
		rmSetSeaLevel(1.0);
	    
	    // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    // SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0);
	
	    // PICKS DEFAULT WATER:
	    rmSetSeaType("hudson bay");
		
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	
	    // PICKS DEFAULT TERRAIN:
		rmSetBaseTerrainMix("saguenay tundra");
	
	    // TERRAIN INITIALIZATION:
		rmTerrainInitialize("saguenay\ground1_sag",5);
			
	    // SET MAP TYPE:
		rmSetMapType("saguenay");
		rmSetMapType("water");
	    rmSetMapType("grass");
	
	    // SET LIGHTING:
		rmSetLightingSet("saguenay");
				
		// CHOOSE THE MERCS:
		chooseMercs();
	
	    // SET WORLD CIRCLE CONSTRAINT: (MAKE THE CORNERS:)
		rmSetWorldCircleConstraint(true);
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*===============================================================================================================*/
// ************************* DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
	    rmDefineClass("classSocket");
		rmDefineClass("classWall");
		rmDefineClass("nuggets");
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// *********************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
        
        // CARDINAL DIRECTIONS:
        int Northward=rmCreatePieConstraint("northMapConstraint", 0.55, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
        int Southward=rmCreatePieConstraint("southMapConstraint", 0.45, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
        int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.45, 0.55, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
        int Westward=rmCreatePieConstraint("westMapConstraint", 0.55, 0.45, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	    // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
	     
        // NATURE AVOIDANCE:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 25.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 10.0);

        // FOREST AVOIDANCE:
		int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
		
		// WALL CONSTRAINT:
		int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 10.0);
	    int avoidCloseWall=rmCreateClassDistanceConstraint("close avoids wall", rmClassID("classWall"), 2.0);
	        
		// RESOURCE AVOIDANCE:
		int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
			    
		// FAST COIN AVOIDANCE:
		int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 30.0);
        int avoidCloseFastCoin=rmCreateTypeDistanceConstraint("close avoids coin", "gold", 2.0);	
				
	    // FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
			
        // NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 25.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
        		
		// ELK AVOIDANCE:
		int avoidElk=rmCreateTypeDistanceConstraint("elk avoids food", "elk", 10.0);
        int avoidCloseElk=rmCreateTypeDistanceConstraint("close avoids elk", "elk", 2.0);
      		
		// MOOSE AVOIDANCE:
		int avoidMoose=rmCreateTypeDistanceConstraint("moose avoids food", "moose", 10.0);
        int avoidCloseMoose=rmCreateTypeDistanceConstraint("close avoids moose", "moose", 2.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
				
		// COW AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		      
        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close impassable land", "Land", false, 2.0);
        int avoidFarImpassableLand=rmCreateTerrainDistanceConstraint("far avoid impassable land", "Land", false, 10.0);

        // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 8.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
        int ferryOnShore=rmCreateTerrainMaxDistanceConstraint("ferry v. water", "water", true, 12.0);
        int nearWater10 = rmCreateTerrainDistanceConstraint("near water", "Water", true, 10.0);

        // NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 10);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
	    int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);

	    // TRADE ROUTE AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
        int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
		
		// SOCKET AVOIDANCE:
		int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 10.0);
		int avoidCloseSocket = rmCreateClassDistanceConstraint("close avoid socket", rmClassID("classSocket"), 2.0);
        		
		// IMPORTANT ITEM AVOIDANCE:
		int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
        		
		// DECORATIONS AVOIDANCE:
		int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

       	// STARTING UNITS AVOIDANCE:
		int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
 
		// CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

        // SHIPS VS. SHIPS:
        int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);           
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// ******************************************** DEFINE OBJECTS: ************************************************ //
// ************************* THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER: ************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE MAIN RIVER: *************************************** //
/*===============================================================================================================*/

        int pugetSound = -1;
	    
		pugetSound = rmRiverCreate(-1, "saguenay lake", 5, 5, 25, 25);
	    
		rmRiverSetConnections(pugetSound, 0.0, 0.2, 0.8, 1);
	
        rmRiverBuild(pugetSound);
        
		// rmRiverReveal(pugetSound, 2); 
		
/*===============================================================================================================*/		
// ************************************* DEFINE AND PLACE THE TRIB RIVER: ************************************** //
/*===============================================================================================================*/
	    
		// TRIB RIVER:
		
		int columbiaRiver = rmRiverCreate(-1, "saguenay lake", 5, 5, 15, 15);
		
		rmRiverConnectRiver(columbiaRiver, pugetSound, 0.5, 0.75, 0.25);
		
		rmRiverSetShallowRadius(columbiaRiver, 7);
		
		rmRiverAddShallow(columbiaRiver, 0.35);
		
		rmRiverBuild(columbiaRiver);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*===============================================================================================================*/
        if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.825,0.725);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.275,0.175);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	}   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// ******************************************** SET UP PLAYER AREAS: ******************************************* //
/*===============================================================================================================*/
        
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
        
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // CLEAR OUT CONSTRAINTS FOR GOOD MEASURES:
        rmClearClosestPointConstraints();
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // THE TRADE ROUTES:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*---------------------------------------------------------------------------------------------------------------*/

		int tradeRoute1ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute1ID, 0.025, 0.525);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.475, 0.975);

	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");
		
		// ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.075);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.925);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
     
        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.30, 0.90);
	} 

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.425, 0.375);
	} 	
   
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.625, 0.575);
	}  
	
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.875, 0.325);
	} 	

/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv4 == rmGetCivID("cherokee"))
	{  
		int cherokee5VillageID = -1;
		cherokee5VillageID = rmCreateGrouping("cherokee village 5", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee5VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee5VillageID, 0.0);
		rmAddGroupingToClass(cherokee5VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee5VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee5VillageID, 0, 0.675, 0.125);
	}  	
	
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv5 == rmGetCivID("cherokee"))
	{  
		int cherokee6VillageID = -1;
		cherokee6VillageID = rmCreateGrouping("cherokee village 6", "native cherokee village 5");
		rmSetGroupingMinDistance(cherokee6VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee6VillageID, 0.0);
		rmAddGroupingToClass(cherokee6VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee6VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee6VillageID, 0, 0.1, 0.7);
	} 	
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// ****************************** DEFINE THE STARTING TCID AND STARTING UNITS: ********************************* //
/*===============================================================================================================*/
 
	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
	    rmAddObjectDefConstraint(startingUnits, avoidWater8);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
		rmSetObjectDefMaxDistance(startingTCID, 0.0);
		
/*===============================================================================================================*/
// ************************************* DEFINE THE STARTING RESOURCES: **************************************** //
/*===============================================================================================================*/

        // DEFINE THE STARTING COWS:
		int StartCowID=rmCreateObjectDef("Starting Cows 1");
        rmAddObjectDefItem(StartCowID, "cow", rmRandInt(3,5), 4.0);
        rmSetObjectDefMinDistance(StartCowID, 25.0);
        rmSetObjectDefMaxDistance(StartCowID, 30.0);
	    rmAddObjectDefConstraint(StartCowID, avoidCow);
		rmAddObjectDefToClass(StartCowID, rmClassID("startingUnit"));
		rmAddObjectDefConstraint(StartCowID, avoidStartingUnitsSmall);
		
		
		// DEFINE THE STARTING BERRYBUSH:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 5, 4.0);
		rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartBerriesID, 20.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 25.0);
		rmAddObjectDefConstraint(StartBerriesID, avoidFruits);
	    rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnitsSmall);
			    
		// DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeSaguenay", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 15.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 25.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING DEERS:
		int StartDeerID=rmCreateObjectDef("starting deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 1, 0.0);
	    rmSetObjectDefMinDistance(StartDeerID, 15.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 25.0);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);
		
		// DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    		
		// DEFINE THE VARIABLE FOR THE STARTING GOLD:
		int silverID = -1;
	    int silverType = rmRandInt(1,10);
	    int playerGoldID = -1;

	    // DEFINE THE VARIABLE FOR THEVSTARTING WATER FLAG:
		int waterFlagID = -1;

/*===============================================================================================================*/
// ******************* PLACE THE STARTING TCID AND THE STARTING UNITS AND STARTING RESOURCES: ****************** //
/*===============================================================================================================*/
	
	    for(i=1; <cNumberPlayers)
	{
		// PLACE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS TWO ORE GROUPINGS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(playerGoldID, avoidWater8);
		rmAddObjectDefConstraint(playerGoldID, avoidFastCoin);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACING THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING STARTING COWS:
		rmPlaceObjectDefAtLoc(StartCowID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING STARTING PRONGHORNS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// DEFINE AND PLACING THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		//rmAddClosestPointConstraint(flagBoxConstraint);		
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
		
	}
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*===============================================================================================================*/
	
	    // THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.80, 0.50);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.50, 0.20);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.175, 0.625);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.375, 0.825);	

/*---------------------------------------------------------------------------------------------------------------*/
        
		// THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.175, 0.825);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.825, 0.175);

/*---------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 4:
		int gold4ID = rmCreateObjectDef("gold 4");
		rmAddObjectDefItem(gold4ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold4ID, 0.0);
		rmSetObjectDefMaxDistance(gold4ID, 0.0);
		rmAddObjectDefConstraint(gold4ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.175, 0.175);
		rmPlaceObjectDefAtLoc(gold4ID, 0, 0.825, 0.825);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.30);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.60, 0.20);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.70, 0.50);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.80, 0.40);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.135, 0.765);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.765, 0.135);

        rmPlaceObjectDefAtLoc(deer2ID, 0, 0.235, 0.865);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.865, 0.235);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.05, 0.65);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.65, 0.05);

        rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.35, 0.95);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.95, 0.35);

/*---------------------------------------------------------------------------------------------------------------*/
		
        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.635, 0.165);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.465, 0.325);

        rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.675, 0.525);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.835, 0.365);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.05, 0.45);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.45, 0.05);

        rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.95, 0.55);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.40, 0.25);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.55, 0.10);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.75, 0.60);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.90, 0.45);

/*---------------------------------------------------------------------------------------------------------------*/

		int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.125, 0.575);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.285, 0.715);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.425, 0.875);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.565, 0.565);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.425, 0.425);
		
/*---------------------------------------------------------------------------------------------------------------*/		
		
        int berries4ID = rmCreateObjectDef("The Berries 4");
		rmAddObjectDefItem(berries4ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries4ID, 0.0);
		rmSetObjectDefMaxDistance(berries4ID, 0.0);
		rmAddObjectDefConstraint(berries4ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.375, 0.065);
		rmPlaceObjectDefAtLoc(berries4ID, 0, 0.935, 0.625);	

/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE COWS: ****************************************** //		
/*================================================================================================================*/
	
        int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.375, 0.325);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.675, 0.625);	
		
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.85, 0.45);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.15);

        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.1, 0.5);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.5, 0.9);	

        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.9, 0.6);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.4, 0.1);	
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE PERCHING VULTURES: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.325, 0.275);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.725, 0.675);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.225, 0.675);

/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE BIG DECORATIVE THINGS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	    int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 25.0);
	    rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	    rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	    rmSetObjectDefMaxDistance(bigDecorationID, 0.0);
	    rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	    
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.825, 0.575);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.425, 0.175);
		rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.325, 0.775);
		
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE SOME ROCK WALLS: ************************************** //
/*===============================================================================================================*/

	    int stoneWallType = -1;
	    int stoneWallID = -1;
	    int stoneWallCount = cNumberNonGaiaPlayers*2;	
	    rmEchoInfo("stoneWall count = "+stoneWallCount);

	    for(i=0; < stoneWallCount)
   {
		stoneWallType = rmRandInt(1,4);
        stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWallID, 0.0);
        rmSetGroupingMaxDistance(stoneWallID, 0.0);
		rmAddGroupingConstraint(stoneWallID, wallConstraint);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.75, 0.45);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.55, 0.25);
   }
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*===============================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
		int forestTreeID = 0;
        int numTries=6*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest pine forest"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        rmSetAreaForestType(forest, "saguenay forest");
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
        rmAddAreaConstraint(forest, avoidWater8);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
	
/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("forest pine forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        rmSetAreaForestType(forest2, "saguenay forest");
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        rmAddAreaConstraint(forest2, avoidWater8);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  	
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*===============================================================================================================*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*===============================================================================================================*/
// ********************************* DEFINE AND PLACE THE FAST COIN -- WHALES: ********************************* //
/*===============================================================================================================*/

	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "beluga", 2, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, 0.0);
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.6, 0.8);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.4, 0.6);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.2, 0.4);
				
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ***************************************** // 
/*===============================================================================================================*/
 








































